Package org.zkoss.stateless.sul

## Interface IProgressmeter

- All Superinterfaces:
    `IAnyGroup<IProgressmeter>`, `IComponent<IProgressmeter>`, `IHtmlBasedComponent<IProgressmeter>`, `IXulElement<IProgressmeter>`

      public interface IProgressmeter
      extends IXulElement<IProgressmeter>, IAnyGroup<IProgressmeter>

  Immutable `Progressmeter` component

  A progress meter is a bar that indicates how much of a task has been completed.

  Author:
    katherine
  See Also:
    `Progressmeter`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IProgressmeter.Builder` | Builds instances of type `IProgressmeter`.
    `static class` | `IProgressmeter.Updater` | Builds an updater of type `IProgressmeter` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IProgressmeter` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default int` | `getValue()` | Returns the current value of the progress meter.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `default java.lang.String` | `getWidth()` | Returns the width.
    `default boolean` | `isIndeterminate()` | Returns the indeterminate state of the progress meter.
    `static IProgressmeter` | `of​(int value)` | Returns the instance with the given value.
    `static IProgressmeter` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `static IProgressmeter` | `ofWidth​(java.lang.String width)` | Returns the instance with the given width.
    `IProgressmeter` | `withIndeterminate​(boolean indeterminate)` | Returns a copy of `this` immutable component with the specified `indeterminate`.
    `IProgressmeter` | `withValue​(int value)` | Returns a copy of `this` immutable component with the specified `value`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IProgressmeter DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `zul.wgt.Progressmeter"`

      Specified by:
        `getWidgetClass` in interface `IComponent<IProgressmeter>`

    - #### getValue

          default int getValue()

      Returns the current value of the progress meter.

    - #### withValue

          IProgressmeter withValue​(int value)

      Returns a copy of `this` immutable component with the specified `value`.

      Sets the current value of the progress meter.

      Parameters:
        `value` - The current value of the progress meter.

        Default: `0`.

      Returns:
        A modified copy of the `this` object

    - #### isIndeterminate

          default boolean isIndeterminate()

      Returns the indeterminate state of the progress meter.(default false)

    - #### withIndeterminate

          IProgressmeter withIndeterminate​(boolean indeterminate)

      Returns a copy of `this` immutable component with the specified `indeterminate`.

      Sets the indeterminate state of the progress meter.

      Parameters:
        `indeterminate` - The indeterminate state of the progress meter.

        Default: `false`.

      Returns:
        A modified copy of the `this` object

    - #### getWidth

          default java.lang.String getWidth()

      Returns the width.

      Default: `"100px"`

      Specified by:
        `getWidth` in interface `IHtmlBasedComponent<IProgressmeter>`

    - #### of

          static IProgressmeter of​(int value)

      Returns the instance with the given value.
      Parameters:
        `value` - The current value of the progress meter.
      Returns:

    - #### ofWidth

          static IProgressmeter ofWidth​(java.lang.String width)

      Returns the instance with the given width.
      Parameters:
        `width` - The width of the component.

    - #### ofId

          static IProgressmeter ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component